<script>
	import { getContext, onMount } from 'svelte'
	import Leaflet from './leaflet.svelte'
	let popup
	let popupElement

	let showContents = false
	let isOpen = false
	const layer = getContext('layer')()

	onMount(async () => {
		const Leaflet = await import('leaflet')

		popup = Leaflet.popup().setContent(popupElement)
		layer.bindPopup(popup)
		layer.on('popupopen', () => {
			isOpen = true
			showContents = true
		})

		layer.on('popupclose', () => {
			isOpen = false

			setTimeout(() => {
				if (!isOpen) showContents = false
			}, 500)
		})

		return () => {
			if (popup) {
				layer.unbindPopup()
				popup.remove()
			}
		}
	})
</script>

<div bind:this={popupElement} class={$$restProps.class}>
	{#if showContents}
		<slot />
	{/if}
</div>

<style>
	:global(.leaflet-popup-content-wrapper) {
		border-radius: 5px;
	}
	:global(.leaflet-popup-content p),
	:global(.leaflet-popup-content a) {
		margin: 0;
	}
</style>
